effect give @a saturation 20 0 true
execute at @e[type=minecraft:armor_stand,tag=wizard] run particle portal ~ ~1 ~ 0.1 1 0.1 1 5 force
execute at @e[type=area_effect_cloud,scores={floater=1..4}] run particle cloud ~ ~ ~ 0 0 0 1 0 force

#Put Fires Out#
scoreboard players add fireout counter 1
execute if score fireout counter matches 100 as @a at @s run fill ~-3 ~-3 ~-3 ~3 ~3 ~3 air replace fire
execute if score fireout counter matches 100.. run scoreboard players set fireout counter 0

#Ravager Hit#
scoreboard players add @e[type=ravager,tag=smiter] counter 1
execute as @e[type=ravager,tag=smiter,scores={counter=20}] at @s run teleport @s ~ -100 ~
kill @e[type=ravager,tag=smiter,scores={counter=20}]

#Story Beginning# wizard0
scoreboard players add story6 counter 1
execute if score story6 counter matches 80 at @e[type=area_effect_cloud,tag=wizard] run playsound wizard0 voice @a ~ ~ ~ 10 1
execute if score story6 counter matches 80 run tellraw @a ["",{"text":"Wizard Teddy: ","bold":true,"color":"light_purple"},"Bow before the all powerful TEDDYYYYY!!!"]
execute if score story6 counter matches 120 run scoreboard players set wizgo counter 1

#Floating Rocks# N S W E
    #Movement#
scoreboard players add float counter 1
execute if score float counter matches 20 as @e[type=area_effect_cloud,scores={floater=1}] at @s run teleport @s ~ ~ ~-1
execute if score float counter matches 20 as @e[type=area_effect_cloud,scores={floater=2}] at @s run teleport @s ~ ~ ~1
execute if score float counter matches 20 as @e[type=area_effect_cloud,scores={floater=3}] at @s run teleport @s ~-1 ~ ~
execute if score float counter matches 20 as @e[type=area_effect_cloud,scores={floater=4}] at @s run teleport @s ~1 ~ ~
    #Build#
execute if score float counter matches 20 as @e[type=area_effect_cloud,scores={floater=1..4}] at @s run function edd:dream/wizard/buildrock
execute if score float counter matches 20.. run scoreboard players set float counter 0
    #Float 1#
execute positioned -2463 -20 300 as @e[type=area_effect_cloud,tag=float1,scores={floater=2},distance=..0.5] run scoreboard players set @s floater 1
execute positioned -2463 -20 285 as @e[type=area_effect_cloud,tag=float1,scores={floater=1},distance=..0.5] run scoreboard players set @s floater 2
    #Float 2#
execute positioned -2470 -20 314 as @e[type=area_effect_cloud,tag=float2,scores={floater=2},distance=..0.5] run scoreboard players set @s floater 1
execute positioned -2470 -20 307 as @e[type=area_effect_cloud,tag=float2,scores={floater=1},distance=..0.5] run scoreboard players set @s floater 2
    #Float 3#
execute positioned -2478 -19 281 as @e[type=area_effect_cloud,tag=float3,scores={floater=3},distance=..0.5] run scoreboard players set @s floater 4
execute positioned -2463 -19 281 as @e[type=area_effect_cloud,tag=float3,scores={floater=4},distance=..0.5] run scoreboard players set @s floater 3
    #Float 4#
execute positioned -2479 -16 305 as @e[type=area_effect_cloud,tag=float4,scores={floater=2},distance=..0.5] run scoreboard players set @s floater 1
execute positioned -2479 -16 295 as @e[type=area_effect_cloud,tag=float4,scores={floater=1},distance=..0.5] run scoreboard players set @s floater 2
    #Float 5#
execute positioned -2490 -16 301 as @e[type=area_effect_cloud,tag=float5,scores={floater=3},distance=..0.5] run scoreboard players set @s floater 4
execute positioned -2484 -16 301 as @e[type=area_effect_cloud,tag=float5,scores={floater=4},distance=..0.5] run scoreboard players set @s floater 3

#Wizard Spells#
execute if score wizgo counter matches 1 run scoreboard players add wizard counter 1
execute if score wizard counter matches 300 if score wizgo counter matches 1 run function edd:dream/wizard/decide
execute as @e[type=armor_stand,tag=wizard] at @s facing entity @p feet run teleport @s ~ ~ ~ ~ 0
execute as @e[type=area_effect_cloud,tag=wizard] at @s facing entity @p feet run teleport @s ~ ~ ~ ~ ~

    #Fire Blast#
execute if score rng random_data matches 0 if score wizard counter matches 300 as @e[type=area_effect_cloud,tag=wizard] at @s facing entity @p feet run function edd:dream/wizard/fireblast

    #Fire Balls#
execute if score rng random_data matches 1 if score wizard counter matches 300 as @e[type=area_effect_cloud,tag=wizard] at @s facing entity @p feet run function edd:dream/wizard/fireballs

    #Levitation Proectile#
execute if score rng random_data matches 2 if score wizard counter matches 300 as @e[type=area_effect_cloud,tag=wizard] at @s facing entity @p feet run function edd:dream/wizard/levitation

execute as @e[type=area_effect_cloud,tag=levi] at @s run teleport @s ^ ^ ^0.3
execute at @e[type=area_effect_cloud,tag=levi] as @a[distance=..2] run effect give @s levitation 1 50
scoreboard players add @e[type=area_effect_cloud,tag=levi] counter 1
execute as @e[type=area_effect_cloud,tag=levi,scores={counter=1}] at @s run playsound minecraft:entity.bee.pollinate master @a ~ ~ ~ 1 0.0
scoreboard players set @e[type=area_effect_cloud,tag=levi,scores={counter=10..}] counter 0
execute at @e[type=minecraft:area_effect_cloud,tag=levi] run particle dust 0.686 0 0.686 1 ~ ~ ~ 0.5 0.5 0.5 0 40 normal

    #Beam#
execute if score rng random_data matches 3 if score wizard counter matches 300 as @e[type=area_effect_cloud,tag=wizard] at @s facing entity @p feet run function edd:dream/wizard/beamgo
execute as @e[type=area_effect_cloud,tag=pop,nbt={Age:60}] at @s run summon firework_rocket ~ ~ ~ {LifeTime:0,FireworksItem:{id:"firework_rocket",Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;16711680],FadeColors:[I;16768734]}]}}}}

    #Push Bomb#
execute if score rng random_data matches 4 if score wizard counter matches 300 as @e[type=area_effect_cloud,tag=wizard] at @s facing entity @p feet run function edd:dream/wizard/push

execute as @e[type=area_effect_cloud,tag=push] at @s run teleport @s ^ ^ ^0.3
execute as @e[type=area_effect_cloud,tag=push] at @s if entity @p[distance=..3] run function edd:dream/wizard/pushing
scoreboard players add @e[type=area_effect_cloud,tag=push] counter 1
execute as @e[type=area_effect_cloud,tag=push,scores={counter=1}] at @s run playsound minecraft:entity.bee.pollinate master @a ~ ~ ~ 1 0.0
scoreboard players set @e[type=area_effect_cloud,tag=push,scores={counter=10..}] counter 0
execute at @e[type=minecraft:area_effect_cloud,tag=push] run particle cloud ~ ~ ~ 0.3 0.3 0.3 0 10 normal
execute as @e[type=area_effect_cloud,tag=pushing,nbt={Age:20}] at @s run summon ravager ~ ~1 ~ {NoGravity:1b,Silent:1b,Invulnerable:1b,PersistenceRequired:1b,NoAI:1b,StunTick:1,Tags:["smiter"]}

execute if score wizard counter matches 300.. run scoreboard players set wizard counter 0


#Mind Piece#
execute as @a[nbt={Inventory:[{id:"minecraft:warped_fungus_on_a_stick",tag:{ticket:6b}}]}] at @s if entity @e[type=armor_stand,tag=wizard,distance=..3] run function edd:dream/wizard/nextstage
